/* -----------------------------------------
   CAROUSEL INIT - /source/js/cagov/carousel.js
----------------------------------------- */

$(document).ready(function(){
    // Owl Carousel
    // https://github.com/OwlFonk/OwlCarousel2
	// Requires Owl Carousel 2.0.3+
	
	// Banner Carousel Plugin
	(function($) {
		$.fn.owlBannerCarousel = function(options){
			var settings = $.extend({
				delay: 4000,
				smallSearch: true
			},options);
			
			return this.each(function(){
				if(settings.smallSearch) {
					$('.navigation-search').addClass('small-search');
				}
			
				$('.header-slideshow-banner').addClass('enabled');
				
				var $this = $(this);
				
				// If browser is IE9 and below set transition speed to 0
				var transitionSpeed = (!$('html').hasClass('oldie')) ? 250 : 0;
				
				// Initiate carousel
				$this.owlCarousel({
					//responsiveRefreshRate: 0,
					items: 1,
					smartSpeed: transitionSpeed,
					animateOut: 'fadeOut',
					loop: true,
					autoplay: true,
					autoplayTimeout: settings.delay,
					autoplayHoverPause: true,
					mouseDrag: false,
					touchDrag: false,
					pullDrag: false,
					pagination: true,
					dotsClass: 'banner-pager',
					dotClass: 'banner-control',
					dotsContainer: false
				});
				
				// Add pause and play buttons
				var owlBannerControl = $('<div class="banner-play-pause"><div class="banner-control"><span class="play ca-gov-icon-carousel-play" aria-hidden="true"></span><span class="pause ca-gov-icon-carousel-pause" aria-hidden="true"></span></div></div>');
				$this.append(owlBannerControl);
				var playControl = owlBannerControl.find('.play').hide();
				var pauseControl = owlBannerControl.find('.pause');
				
				playControl.on('click', function() {
					$(this).hide();
					$(this).parent().removeClass('active');
					pauseControl.show();
					$this.trigger('play.owl.autoplay', [settings.delay]);
					$this.owlCarousel('next'); // Manually play next since autoplay waits for delay
				});
				
				pauseControl.on('click', function() {
					$(this).hide(); 
					$(this).parent().addClass('active');
					playControl.show();
					$this.trigger('stop.owl.autoplay');
				});
				
				// Number the items in .banner-pager
				var dots = $('.banner-pager .banner-control');
				dots.each(function(){
					$(this).find('span').append($(this).index() + 1);
				});
			});
		}
	}(jQuery));
	
	// Banner Carousel Init
	$("body.primary .carousel-banner").owlBannerCarousel();
	// Init with options: $(".banner-carousel").owlBannerCarousel({delay: 4000, smallSearch:true});
	
if($.fn.owlCarousel) {
	// Media Carousel Init
	$(".carousel-media").owlCarousel({
		autoWidth: true,
		margin: 25,
		nav: true,
		navText: ['<span class="ca-gov-icon-arrow-prev" aria-hidden="true"></span>','<span class="ca-gov-icon-arrow-next" aria-hidden="true"></span>'],
		dots: false
	});
	
	// Link Icon Carousel Init
	$(".carousel-link").owlCarousel({
		margin: 25,
		autoWidth: true,
		nav: true,
		navText: ['<span class="ca-gov-icon-arrow-prev" aria-hidden="true"></span>','<span class="ca-gov-icon-arrow-next" aria-hidden="true"></span>'],
		dots: false
	});
	
	// Social Media Slider Init
	$(".carousel-slider").owlCarousel({
		items: 1,
		nav: true,
		navText: ['<span class="ca-gov-icon-arrow-prev" aria-hidden="true"></span>','<span class="ca-gov-icon-arrow-next" aria-hidden="true"></span>'],
		dots: false
	});
	
	// Gallery Image Slider
	$(".carousel-gallery").owlCarousel({
		items: 1,
		nav: true,
		navText: ['<span class="ca-gov-icon-arrow-prev" aria-hidden="true"></span>','<span class="ca-gov-icon-arrow-next" aria-hidden="true"></span>'],
		dots: false
	});
}
});
